/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the IdentityMembershipInfo type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &IdentityMembershipInfo{}

// IdentityMembershipInfo struct for IdentityMembershipInfo
type IdentityMembershipInfo struct {
	MemberIdentity *IdentityInfo  `json:"memberIdentity,omitempty"`
	Comment        NullableString `json:"comment,omitempty"`
}

// NewIdentityMembershipInfo instantiates a new IdentityMembershipInfo object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewIdentityMembershipInfo() *IdentityMembershipInfo {
	this := IdentityMembershipInfo{}
	return &this
}

// NewIdentityMembershipInfoWithDefaults instantiates a new IdentityMembershipInfo object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewIdentityMembershipInfoWithDefaults() *IdentityMembershipInfo {
	this := IdentityMembershipInfo{}
	return &this
}

// GetMemberIdentity returns the MemberIdentity field value if set, zero value otherwise.
func (o *IdentityMembershipInfo) GetMemberIdentity() IdentityInfo {
	if o == nil || IsNil(o.MemberIdentity) {
		var ret IdentityInfo
		return ret
	}
	return *o.MemberIdentity
}

// GetMemberIdentityOk returns a tuple with the MemberIdentity field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *IdentityMembershipInfo) GetMemberIdentityOk() (*IdentityInfo, bool) {
	if o == nil || IsNil(o.MemberIdentity) {
		return nil, false
	}
	return o.MemberIdentity, true
}

// HasMemberIdentity returns a boolean if a field has been set.
func (o *IdentityMembershipInfo) HasMemberIdentity() bool {
	if o != nil && !IsNil(o.MemberIdentity) {
		return true
	}

	return false
}

// SetMemberIdentity gets a reference to the given IdentityInfo and assigns it to the MemberIdentity field.
func (o *IdentityMembershipInfo) SetMemberIdentity(v IdentityInfo) {
	o.MemberIdentity = &v
}

// GetComment returns the Comment field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *IdentityMembershipInfo) GetComment() string {
	if o == nil || IsNil(o.Comment.Get()) {
		var ret string
		return ret
	}
	return *o.Comment.Get()
}

// GetCommentOk returns a tuple with the Comment field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *IdentityMembershipInfo) GetCommentOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Comment.Get(), o.Comment.IsSet()
}

// HasComment returns a boolean if a field has been set.
func (o *IdentityMembershipInfo) HasComment() bool {
	if o != nil && o.Comment.IsSet() {
		return true
	}

	return false
}

// SetComment gets a reference to the given NullableString and assigns it to the Comment field.
func (o *IdentityMembershipInfo) SetComment(v string) {
	o.Comment.Set(&v)
}

// SetCommentNil sets the value for Comment to be an explicit nil
func (o *IdentityMembershipInfo) SetCommentNil() {
	o.Comment.Set(nil)
}

// UnsetComment ensures that no value is present for Comment, not even an explicit nil
func (o *IdentityMembershipInfo) UnsetComment() {
	o.Comment.Unset()
}

func (o IdentityMembershipInfo) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o IdentityMembershipInfo) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.MemberIdentity) {
		toSerialize["memberIdentity"] = o.MemberIdentity
	}
	if o.Comment.IsSet() {
		toSerialize["comment"] = o.Comment.Get()
	}
	return toSerialize, nil
}

type NullableIdentityMembershipInfo struct {
	value *IdentityMembershipInfo
	isSet bool
}

func (v NullableIdentityMembershipInfo) Get() *IdentityMembershipInfo {
	return v.value
}

func (v *NullableIdentityMembershipInfo) Set(val *IdentityMembershipInfo) {
	v.value = val
	v.isSet = true
}

func (v NullableIdentityMembershipInfo) IsSet() bool {
	return v.isSet
}

func (v *NullableIdentityMembershipInfo) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableIdentityMembershipInfo(val *IdentityMembershipInfo) *NullableIdentityMembershipInfo {
	return &NullableIdentityMembershipInfo{value: val, isSet: true}
}

func (v NullableIdentityMembershipInfo) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableIdentityMembershipInfo) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
